package ru.dbotthepony.mc.otm.menu.tech

import com.google.common.collect.ImmutableList
import net.minecraft.server.level.ServerPlayer
import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.tech.PlatePressBlockEntity
import ru.dbotthepony.mc.otm.menu.MachineOutputSlot
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.MatterySlot
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class PlatePressMenu @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: PlatePressBlockEntity? = null
) : MatteryPoweredMenu(MMenus.PLATE_PRESS, containerID, inventory, tile) {
	val container = tile?.container ?: SimpleContainer(2)

	val inputSlot = MatterySlot(container, PlatePressBlockEntity.SLOT_INPUT)
	val outputSlot = MachineOutputSlot(container, PlatePressBlockEntity.SLOT_OUTPUT) { tile?.popExperience(ply as ServerPlayer) }

	override val storageSlots: List<MatterySlot> = ImmutableList.of(inputSlot, outputSlot)

	val progressGauge = if (tile != null) ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess) else ProgressGaugeWidget(this)

	init {
		addSlot(inputSlot)
		addSlot(outputSlot)
		addInventorySlots()
	}
}
